Status: Closed

Priority: Low

Assignee: Denis Rouzaud

Category: Edit widget

Affected QGIS version:2.4.0 Regression?: No
Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: worksforme
Crashes QGIS or corrupls data: Copied to github as #: 19547
Description

When a DateTime editor widget is populated with an invalid value, a NULL value is returned instead (even if NULL values are turned off in
the edit widget).

E.g. The data has a date "2014-00-19" (which is kind of meaningless) and will not be able to interpret this. Just shortly opening this form in
the dual view will result in the field being set to NULL.

I am not 100% sure how to deal with this situation, but | think that it would be more appropriate to just leave the field value untouched if
the user does not touch it. Having the widget wrapper return an invalid QVariant instead of a NULL QVariant should fix it this way.

History

#1 - 2014-09-22 11:32 PM - Denis Rouzaud

The problem you raise occurs when widget is badly configured.

The only way | see to bypass this, would be to save the date in a private var, modify it when needed and return it for the value() method.

This bug is very likely to arise since the widget was badly configured in 2.4 (when importing older projects). Anyway, it's more likely that harm has been
done and projects already fixed.

Not sure it is worth adding such trick in there.

What do you think?

#2 - 2014-09-23 12:48 AM - Matthias Kuhn
- Priority changed from Normal to Low

| relaized that there are other widgets as well that don't behave fine.
In an optimal scenario, widgets would only change the data below them if touched. They are allowed to return an invalid QVariant to specify that. So they
don't need to remember the original value but just need to remember if they have been changed.

#3 - 2017-05-01 01:08 AM - Giovanni Manghi
- Easy fix? set to No

- Regression? set to No

#4 - 2018-10-22 06:36 PM - Denis Rouzaud
- Description updated

Matthias, can this be closed?

#5 - 2018-10-22 08:04 PM - Giovanni Manghi

- Status changed from Open to Feedback

#6 - 2018-10-25 10:25 AM - Matthias Kuhn

| don't remember fixing this (but my brain sometimes forgets things)

If it works now, it's probably fixed.

#7 - 2018-11-11 04:42 AM - Jiirgen Fischer
- Resolution set to worksforme

- Status changed from Feedback to Closed
